/*****************************************************************************
* Filename: SDTYPES.H
*
* f[^^̒`
*
*****************************************************************************/

#ifndef _SDTYPES_H_

#ifndef TRUE
#define TRUE    1
#endif
#ifndef FALSE
#define FALSE   0    
#endif
//typedef enum SD_YES_NO
typedef enum 
{
	NO  = FALSE,
	YES = TRUE
} SDBOOL;

typedef char            CHAR;   /*  8-bit signed */
typedef char            INT08;  /*  8-bit signed */
typedef char            int8_t;  /*  8-bit signed */
typedef short           int16_t;  /* 16-bit signed */
typedef short           INT16;  /* 16-bit signed */
typedef short           COUNT;  /* 16 bit signed */
typedef int            INT32;  /* 32-bit signed */
typedef int            int32_t;  /* 32-bit signed */
typedef long            LONG;   /* 64-bit signed */
typedef long            int64_t;   /* 64-bit signed */
typedef unsigned char   UCHAR;  /*  8-bit unsigned */
typedef unsigned char   u_char;  /*  8-bit unsigned */
typedef unsigned char   UINT08; /*  8-bit unsigned */
typedef unsigned short  UINT16; /* 16-bit unsigned */
typedef unsigned short  UCOUNT; /* 16-bit unsigned */
typedef unsigned long   UINT32; /* 32-bit unsigned */
typedef unsigned long   ULONG;  /* 32-bit unsigned */
typedef unsigned long   u_long;  /* 32-bit unsigned */
typedef unsigned long   u_int32_t;  /* 32-bit unsigned */
typedef unsigned long   uint32_t;  /* 32-bit unsigned */
typedef unsigned long   u_int;  /* 32-bit unsigned */
typedef unsigned short  SDWCHAR; /* Unicode character */
typedef unsigned short  u_int16_t; /* Unicode character */
typedef unsigned short  u_short; /* Unicode character */
typedef unsigned char   UTINY;  /* unsigned 8 bit */
typedef unsigned char   u_int8_t;  /* unsigned 8 bit */
typedef unsigned char   *USERADDRESS;
typedef	int32_t		daddr_t;	/* disk address */
typedef	int64_t		off_t;	/* file offset from ansi.h*/

#define SDVOID          void      /* void  */
#define SDIMPORT        extern    /* For external data */
#define SDLOCAL         static    /* For internal data and functions */ 
#define SDGLOBAL        extern    /* For external functions */

#define size_t unsigned int
#define	dev_t unsigned int		/* block special device mounted */

/* Null pointer */
#define SDNULL    ((void *)0)
#define NULL ((void *)0)

struct vop_inactive_args {
	const struct vnodeop_desc *a_desc;
	struct vnode *a_vp;
	struct proc *a_p;
};
/* secter bufer 16384+256 */
struct buf1 {
	unsigned char b_dta[0x4100];
	volatile long	b_flags;	/* B_* flags. */
	int	b_error;		/* Errno value. */
	long	b_bufsize;		/* Allocated buffer size. */
	long	b_bcount;		/* Valid bytes in buffer. */
	long	b_resid;		/* Remaining I/O. */
	dev_t	b_dev;			/* Device associated with buffer. */
	daddr_t	b_lblkno;		/* Logical block number. */
	daddr_t	b_blkno;		/* Underlying physical block number*/
	daddr_t	b_rawblkno;		/* Raw underlying physical block*/
};

/* Timeer Struct  from sys/sys/time.h */
/*
 * Structure defined by POSIX.1b to be like a timeval.
 */
//#define time_t long
//struct timespec {
//	time_t	tv_sec;		/* seconds */
//	long	tv_nsec;	/* and nanoseconds */
//};
//struct timeval {
//  long tv_sec;
//  long tv_usec;
//};

/* IG[R[h */
typedef enum _MMCERROR
{
	MMC_NO_ERROR = 0,               /* 0- Successful completion */
	MMC_CARD_IS_NOT_RESPONDING=201, /* 201- Time out error on card response */
	MMC_CMD_CRC_ERROR,              /* 202- CRC error detected on card response */
	MMC_DATA_CRC_ERROR,             /* 203- CRC error detected on incoming data block */
	MMC_DATA_STATUS_CRC_ERROR,      /* 204- Card is reporting CRC error on outgoing data block. */
	MMC_CARD_IS_BUSY,               /* 205- Card is busy programming */
	MMC_CARD_IS_NOT_READY,          /* 206- Card did not complete its initialization and is not ready. */
	MMC_COMUNC_CRC_ERROR,           /* 207- Card is reporting CRC error */
	MMC_COMUNC_ILLEG_COM,           /* 208- Card is reporting illegal command */
	MMC_ERASE_PARAM,                /* 209- Erase parameters error */
	MMC_WP_VIOLATION,               /* 210- Attempt to write a WP sector */
	MMC_ERROR,                      /* 211- MMC card internal error */
	MMC_WP_ERASE_SKIP,              /* 212- Attempt to erase WP sector */
	MMC_ADDRESS_ERROR,              /* 213- Sector messaligned error */
	MMC_CARD_READ_FAILURE,          /* 214- Card is reporting Read command failed */
	MMC_INTERFACE_ERROR,            /* 215- Error detected by the MMC HW driver */
	MMC_ILLEGAL_MODE,               /* 216- Not support in the current mode */
	MMC_COMMAND_PARAMETER_ERROR,    /* 217- Card is reporting Address-out-of-range error */
	MMC_ERASE_SEQ_ERROR,            /* 218- Error in the sequence of erase command */
	MMC_ERASE_RESET,                /* 219- Erase command canceled before execution */
	MMC_NO_CRC_STATUS,              /* 220- Time out on CRC status for Write */
	MMC_OVERRUN,                    /* 221- Overrun */
	MMC_UNDERRUN,                   /* 222- Underrun */
	MMC_CIDCSD_OVERWRITE,           /* 223- a) The CID register has been already */
					/*        written and can be overwriten. */
					/*     b) The read only section of CSD does not */
					/*        match the card content. */
					/*     c) An attempt to reverse the copy (set */
					/*        as original) or permanent WP bits was made. */
	MMC_CARD_ECC_DISABLED,          /* 224- The command has been executed without */
					/*     using the internal ECC. */
	MMC_READ_FOR_DATA,              /* 225- Corresponds to buffer empty signalling */
					/*     on the bus. */
	MMC_DATA_LENGTH_ERROR,          /* 226- Data Length more then 512 bytes. */
	MMC_TIME_OUT_RCVD,              /* 227- Time out recive data (B0 for controller) */
	MMC_OUT_OF_RANGE,               /* 228- Address out of range error */
	MMC_CARD_ECC_FAILED             /* 229- Internal Card ECC failed */
} MMC_CC;

#define _SDTYPES_H_
#endif

