/******************************************************************************
* FileName:	spiDrv.c
*
* eg[N̒ʐMV[PX
* 
**************************************************************************/

#include "sdconfig.h"
#include    "drive.h"
#include "sdmmc.h"


/******************************************************************************
* Name: receive_data
*
*@MMCMf[^g[NM
*
******************************************************************************/
MMC_CC receive_data( PDEVICE_CONTROLLER pc, UINT16 data_length ) /*__fn__*/
{
	/* f[^g[N̎M */
	return (MMCReceive( (UCHAR *)pc->user_address, data_length));
}

/******************************************************************************
* Name: send_data
*
*@MMCփf[^g[N𑗐M
*
******************************************************************************/
MMC_CC send_data( PDEVICE_CONTROLLER pc, UINT16 data_length ) /*__fn__*/
{
	/* f[^g[N̑M */
	if ( MMCTransmit((UCHAR *)pc->user_address, data_length) != MMC_NO_ERROR )
		return MMC_DATA_STATUS_CRC_ERROR;

	/* J[hBusŷ҂ */
    if ( IsCardBusy(pc) )
		return MMC_CARD_IS_BUSY;

    return MMC_NO_ERROR;
}


/******************************************************************************
* Name: mmcWaitForCmdResponse
*
* MMCMR}hX|Xg[NM
*
******************************************************************************/
MMC_CC mmcWaitForCmdResponse(RESP_TYPE respType)
{
	MMC_CC  respErr;
	UINT16  respStatus;

	/* X|Xg[N̎M */
	respErr = getMMCResponseInfo(&respStatus, (UINT16)respType);
	if ( respErr ==  MMC_CARD_IS_NOT_RESPONDING )
		return respErr;

	respErr = (MMC_CC)respStatus;

	/* X|X͂AG[lɕϊ */
	if ( respStatus == 0 )
		return MMC_NO_ERROR;
	if ( respStatus & CMD_PARAM_ERROR )
		return MMC_COMMAND_PARAMETER_ERROR;
	if ( respStatus & ADDRESS_ERROR )
		return MMC_ADDRESS_ERROR;
	if ( respStatus & ERASE_SEQ_ERROR )
		return MMC_ERASE_SEQ_ERROR;
	if ( respStatus & CMD_CRC_ERROR )
		return MMC_CMD_CRC_ERROR;
	if ( respStatus & COMUNC_ILLEG_COM )
		return MMC_COMUNC_ILLEG_COM;
	if ( respStatus & ERASE_RESET )
		return MMC_ERASE_RESET;
	if ( respStatus & CARD_IS_NOT_READY )
		return MMC_CARD_IS_NOT_READY;
	if ( respStatus & CMD_PARAM_ERROR2 )
		return MMC_COMMAND_PARAMETER_ERROR;
	if ( respStatus & ERASE_PARAM)
		return MMC_ERASE_PARAM;
	if ( respStatus & WP_VIOLATION )
		return MMC_WP_VIOLATION;
	if ( respStatus & CARD_READ_FAILURE )
		return MMC_CARD_READ_FAILURE;
	if (respStatus & EERROR)
		return MMC_ERROR;
	if ( respStatus & ERROR2 )
		return MMC_ERROR;
	if ( respStatus & WP_ERASE_SKIP )
		return MMC_WP_ERASE_SKIP;

	return MMC_CARD_IS_NOT_RESPONDING;
}


/******************************************************************************
* Name: mmcCommandAndResponse
*
* MMCփR}hg[N𑗐MāAX|XM
*
*****************************************************************************/
MMC_CC mmcCommandAndResponse ( PDEVICE_CONTROLLER pc,
		UINT16 Cmd,			/* R}hCfbNX */
		UINT32 Arg,			/* R}h */
		UINT16 noBlocks,	/* f[^]ꍇA]ubN */
		RESP_TYPE Resp 		/* Response Type */
) /*__fn__*/
{
    pc->error_code = NO;

	/* R}hg[N𑗐M */
	if ( MMCPrepareAndSetup(Arg, Cmd, noBlocks, (UINT16)Resp) )
		return MMC_INTERFACE_ERROR;

	/* X|XMAX|Xs */
	return (mmcWaitForCmdResponse(Resp));
}


/******************************************************************************
* Name: IsCardBusy
*
* MMCBusy܂Wait
*
*****************************************************************************/
MMC_CC IsCardBusy(PDEVICE_CONTROLLER pc)
{
    return (checkCardBusy());
}

